public class Neuroschicht
{
     public Neuroschicht vorgaenger = null;
  
     public int vornanz=0;
    
     public int nanz; //Neuronenanzahl
  
     public double[] ausgang; 
  
     public int i,k,p;

     public double[][] w = null; //1. Dimension: vornanz, 2. Dimension: nanz

     public double u;

     public void uebertrageGewichte(double[] ww, int ab_dort)
     {
         for(i=0;i<vornanz;i++)
         {
             for(k=0;k<nanz;k++)
             {
                  w[i][k] = ww[ab_dort];
                  ab_dort++;
             }
         }
     }
  
     public Neuroschicht(int nanz, Neuroschicht vorgaenger)
     {
         this.vorgaenger = vorgaenger;
         this.nanz = nanz;
         ausgang = new double[nanz];
         for(i=0;i<nanz;i++)
             ausgang[i] = 0;
             
         if(vorgaenger!=null)
         {
               vornanz = vorgaenger.holeNeuronenanzahl();
               w = new double[vornanz][nanz];
         }
     }
     
     public int holeNeuronenanzahl()
     {
           return nanz;
     }
     
     public void setzeAusgang(double[] eingang)
     {
         for(i=0;i<nanz;i++)
         {
                 ausgang[i] = eingang[i];
         }
     }
     
     public void aktualisiereAusgang()
     {
         if(vorgaenger!=null)
         {
             for(i=0;i<nanz;i++)
             {
                 u = 0.0;
                 for(k=0;k<vornanz;k++)
                 {
                     u += w[k][i]*vorgaenger.ausgang[k];
                 }
                 
                 ausgang[i] = sigmoid(u);
             }
             
         }    
     }
     
     public double sigmoid(double u)
     {
         double d = 0.01;
         return (   1.0/(1.0 + Math.exp(-d*u))   );
     }
}
